/*-
 * ============LICENSE_START=======================================================
 *  Copyright (C) 2018 Ericsson. All rights reserved.
 * ================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * SPDX-License-Identifier: Apache-2.0
 * ============LICENSE_END=========================================================
 */

package org.onap.policy.apex.testsuites.performance.benchmark.engine.utils;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import org.onap.policy.apex.model.basicmodel.handling.ApexModelException;
import org.onap.policy.apex.model.basicmodel.handling.ApexModelWriter;
import org.onap.policy.apex.model.policymodel.concepts.AxPolicyModel;

/**
 * The Class Utils.
 */
public class Utils {

    /**
     * Instantiates a new utils.
     */
    private Utils() {}

    /**
     * Gets the model string.
     *
     * @param ecaPolicyModel the eca policy model
     * @return the model string
     * @throws ApexModelException the apex model exception
     * @throws IOException Signals that an I/O exception has occurred.
     */
    public static String getModelString(final AxPolicyModel ecaPolicyModel) throws ApexModelException, IOException {
        try (final ByteArrayOutputStream baOutputStream = new ByteArrayOutputStream()) {
            new ApexModelWriter<AxPolicyModel>(AxPolicyModel.class).write(ecaPolicyModel, baOutputStream);
            return baOutputStream.toString();
        }
    }

}
